﻿'Translation from C# to vb was done by JimmyTheGreat
'All comments and overall idea are still owned by Aureus

Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Configuration
Imports System.Drawing

'Namespace $safeprojectname$

Public Class SettingsModel
    Public Property someCheckbox As Boolean

    Private Shared _settingsModel As SettingsModel = Nothing

    Public Sub New()
    End Sub

    Private Sub LoadSettings()
        Dim reader As New AppSettingsReader()

        someCheckbox = getBoolSetting(reader, "Simple.someCheckbox", True)
    End Sub

    Public Sub SaveSettings()
        Dim cfg As System.Configuration.Configuration = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None)

        Dim kv As KeyValueConfigurationCollection = cfg.AppSettings.Settings

        updateKV(kv, "Simple.someCheckbox", TF10(someCheckbox))

        cfg.Save(ConfigurationSaveMode.Modified)
        ConfigurationManager.RefreshSection("appSettings")
    End Sub

    Private Sub updateKV(ByVal kv As KeyValueConfigurationCollection, ByVal key_name As String, ByVal value_string As String)
        kv.Remove(key_name)
        kv.Add(key_name, value_string)
    End Sub

    Public Shared Function getInstance() As SettingsModel
        If _settingsModel Is Nothing Then
            _settingsModel = New SettingsModel

            _settingsModel.LoadSettings()
        End If

        Return _settingsModel
    End Function

    Private Function TF10(ByVal v As Boolean) As String
        Return If(v, "1", "0")
    End Function
    
    Function getBoolSetting(ByVal reader As System.Configuration.AppSettingsReader, ByVal valueName As String, ByVal default_value As Byte) As Boolean
        Try
            Dim o As Object = reader.GetValue(valueName, GetType(Integer))
            If o Is Nothing Then
                Return default_value
            End If
            Return 0 <> CType(o, Integer)
        Catch ex As InvalidOperationException
            Return default_value
        End Try
    End Function

    Function getByteSetting(ByVal reader As System.Configuration.AppSettingsReader, ByVal valueName As String, ByVal default_value As Byte) As Byte
        Try
            Dim o As Object = reader.GetValue(valueName, GetType(Integer))
            If o Is Nothing Then
                Return default_value
            End If
            Return CType(CType(o, Integer), Byte)
        Catch ex As InvalidOperationException
            Return default_value
        End Try
    End Function

    Function getFloatSetting(ByVal reader As System.Configuration.AppSettingsReader, ByVal valueName As String, ByVal default_value As Single) As Single
        Try
            Dim o As Object = reader.GetValue(valueName, GetType(Single))
            If o Is Nothing Then
                Return default_value
            End If
            Return CType(o, Single)
        Catch ex As InvalidOperationException
            Return default_value
        End Try
    End Function

    Function getStringSetting(ByVal reader As System.Configuration.AppSettingsReader, ByVal valueName As String, ByVal default_value As String) As String
        Try
            Dim o As Object = reader.GetValue(valueName, GetType(String))
            If o Is Nothing Then
                Return default_value
            End If
            Return CType(o, String)
        Catch ex As InvalidOperationException
            Return default_value
        End Try
    End Function

End Class

'End Namespace

